# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # AzureWorkload workload-specific backup request.
    #
    class AzureWorkloadBackupRequest < BackupRequest

      include MsRestAzure


      def initialize
        @objectType = "AzureWorkloadBackupRequest"
      end

      attr_accessor :objectType

      # @return [BackupType] Type of backup, viz. Full, Differential, Log or
      # CopyOnlyFull. Possible values include: 'Invalid', 'Full',
      # 'Differential', 'Log', 'CopyOnlyFull'
      attr_accessor :backup_type

      # @return [Boolean] Bool for Compression setting
      attr_accessor :enable_compression

      # @return [DateTime] Backup copy will expire after the time specified
      # (UTC).
      attr_accessor :recovery_point_expiry_time_in_utc


      #
      # Mapper for AzureWorkloadBackupRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureWorkloadBackupRequest',
          type: {
            name: 'Composite',
            class_name: 'AzureWorkloadBackupRequest',
            model_properties: {
              objectType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'objectType',
                type: {
                  name: 'String'
                }
              },
              backup_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupType',
                type: {
                  name: 'String'
                }
              },
              enable_compression: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enableCompression',
                type: {
                  name: 'Boolean'
                }
              },
              recovery_point_expiry_time_in_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recoveryPointExpiryTimeInUTC',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
