# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Extended info class details
    #
    class AzureWorkloadSQLRecoveryPointExtendedInfo

      include MsRestAzure

      # @return [DateTime] UTC time at which data directory info was captured
      attr_accessor :data_directory_time_in_utc

      # @return [Array<SQLDataDirectory>] List of data directory paths during
      # restore operation.
      attr_accessor :data_directory_paths


      #
      # Mapper for AzureWorkloadSQLRecoveryPointExtendedInfo class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureWorkloadSQLRecoveryPointExtendedInfo',
          type: {
            name: 'Composite',
            class_name: 'AzureWorkloadSQLRecoveryPointExtendedInfo',
            model_properties: {
              data_directory_time_in_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataDirectoryTimeInUTC',
                type: {
                  name: 'DateTime'
                }
              },
              data_directory_paths: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataDirectoryPaths',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SQLDataDirectoryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'SQLDataDirectory'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
