# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # The resource storage details.
    #
    class BackupResourceConfig

      include MsRestAzure

      # @return [StorageType] Storage type. Possible values include: 'Invalid',
      # 'GeoRedundant', 'LocallyRedundant'
      attr_accessor :storage_model_type

      # @return [StorageType] Storage type. Possible values include: 'Invalid',
      # 'GeoRedundant', 'LocallyRedundant'
      attr_accessor :storage_type

      # @return [StorageTypeState] Locked or Unlocked. Once a machine is
      # registered against a resource, the storageTypeState is always Locked.
      # Possible values include: 'Invalid', 'Locked', 'Unlocked'
      attr_accessor :storage_type_state


      #
      # Mapper for BackupResourceConfig class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackupResourceConfig',
          type: {
            name: 'Composite',
            class_name: 'BackupResourceConfig',
            model_properties: {
              storage_model_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'storageModelType',
                type: {
                  name: 'String'
                }
              },
              storage_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'storageType',
                type: {
                  name: 'String'
                }
              },
              storage_type_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'storageTypeState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
