# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Additional information of the container.
    #
    class MabContainerExtendedInfo

      include MsRestAzure

      # @return [DateTime] Time stamp when this container was refreshed.
      attr_accessor :last_refreshed_at

      # @return [BackupItemType] Type of backup items associated with this
      # container. Possible values include: 'Invalid', 'VM', 'FileFolder',
      # 'AzureSqlDb', 'SQLDB', 'Exchange', 'Sharepoint', 'VMwareVM',
      # 'SystemState', 'Client', 'GenericDataSource', 'SQLDataBase',
      # 'AzureFileShare', 'SAPHanaDatabase'
      attr_accessor :backup_item_type

      # @return [Array<String>] List of backup items associated with this
      # container.
      attr_accessor :backup_items

      # @return [String] Backup policy associated with this container.
      attr_accessor :policy_name

      # @return [String] Latest backup status of this container.
      attr_accessor :last_backup_status


      #
      # Mapper for MabContainerExtendedInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MabContainerExtendedInfo',
          type: {
            name: 'Composite',
            class_name: 'MabContainerExtendedInfo',
            model_properties: {
              last_refreshed_at: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastRefreshedAt',
                type: {
                  name: 'DateTime'
                }
              },
              backup_item_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupItemType',
                type: {
                  name: 'String'
                }
              },
              backup_items: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupItems',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'policyName',
                type: {
                  name: 'String'
                }
              },
              last_backup_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastBackupStatus',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
