# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # IaaS VM specific backup protection intent item.
    #
    class AzureResourceProtectionIntent < ProtectionIntent

      include MsRestAzure


      def initialize
        @protectionIntentItemType = "AzureResourceItem"
      end

      attr_accessor :protectionIntentItemType

      # @return [String] Friendly name of the VM represented by this backup
      # item.
      attr_accessor :friendly_name


      #
      # Mapper for AzureResourceProtectionIntent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureResourceItem',
          type: {
            name: 'Composite',
            class_name: 'AzureResourceProtectionIntent',
            model_properties: {
              backup_management_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupManagementType',
                type: {
                  name: 'String'
                }
              },
              source_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceResourceId',
                type: {
                  name: 'String'
                }
              },
              item_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'itemId',
                type: {
                  name: 'String'
                }
              },
              policy_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'policyId',
                type: {
                  name: 'String'
                }
              },
              protection_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protectionState',
                type: {
                  name: 'String'
                }
              },
              protectionIntentItemType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'protectionIntentItemType',
                type: {
                  name: 'String'
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'friendlyName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
