# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # Azure storage specific error information
    #
    class AzureWorkloadErrorInfo

      include MsRestAzure

      # @return [Integer] Error code.
      attr_accessor :error_code

      # @return [String] Localized error string.
      attr_accessor :error_string

      # @return [String] Title: Typically, the entity that the error pertains
      # to.
      attr_accessor :error_title

      # @return [Array<String>] List of localized recommendations for above
      # error code.
      attr_accessor :recommendations

      # @return [String] Additional details for above error code.
      attr_accessor :additional_details


      #
      # Mapper for AzureWorkloadErrorInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureWorkloadErrorInfo',
          type: {
            name: 'Composite',
            class_name: 'AzureWorkloadErrorInfo',
            model_properties: {
              error_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorCode',
                type: {
                  name: 'Number'
                }
              },
              error_string: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorString',
                type: {
                  name: 'String'
                }
              },
              error_title: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorTitle',
                type: {
                  name: 'String'
                }
              },
              recommendations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recommendations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              additional_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalDetails',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
