# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # Response contract for enable backup validation request
    #
    class PreValidateEnableBackupResponse

      include MsRestAzure

      # @return [ValidationStatus] Validation Status. Possible values include:
      # 'Invalid', 'Succeeded', 'Failed'
      attr_accessor :status

      # @return [String] Response error code
      attr_accessor :error_code

      # @return [String] Response error message
      attr_accessor :error_message

      # @return [String] Recommended action for user
      attr_accessor :recommendation

      # @return [String] Specifies the product specific container name. E.g.
      # iaasvmcontainer;iaasvmcontainer;rgname;vmname. This is required
      # for portal
      attr_accessor :container_name

      # @return [String] Specifies the product specific ds name. E.g.
      # vm;iaasvmcontainer;rgname;vmname. This is required for portal
      attr_accessor :protected_item_name


      #
      # Mapper for PreValidateEnableBackupResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PreValidateEnableBackupResponse',
          type: {
            name: 'Composite',
            class_name: 'PreValidateEnableBackupResponse',
            model_properties: {
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              error_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorCode',
                type: {
                  name: 'String'
                }
              },
              error_message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorMessage',
                type: {
                  name: 'String'
                }
              },
              recommendation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recommendation',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containerName',
                type: {
                  name: 'String'
                }
              },
              protected_item_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protectedItemName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
